%global srcname google-api-core
%bcond_with tests

Summary:        Core Library for Google Client Libraries
Name:           python-%{srcname}
Version:        2.12.0
Release:        1%{?dist}
License:        ASL 2.0
URL:            https://github.com/googleapis/python-api-core
Source0:        %{url}/archive/refs/tags/v%{version}.tar.gz

BuildRequires:  python3-devel
%if %{with tests}
BuildRequires:  python3dist(google-auth) python3dist(googleapis-common-protos) python3dist(grpcio)
BuildRequires:  python3dist(grpcio-gcp) python3dist(protobuf) python3dist(proto-plus) python3dist(pytest)
BuildRequires:  python3dist(pytz) python3dist(requests) python3dist(six)
%endif

BuildArch:      noarch

%description
This library is not meant to stand-alone.
Instead it defines common helpers used by all Google API clients.


%package -n python3-%{srcname}
Summary:        Core Library for Google Client Libraries
Requires:       python3dist(grpcio) python3dist(grpcio-status)

%description -n python3-%{srcname}
This library is not meant to stand-alone.
Instead it defines common helpers used by all Google API clients.

%pyproject_extras_subpkg -n python3-%{srcname} grpc


%prep
%autosetup -n python-api-core-%{version}
sed -i 's/"protobuf.*",/"protobuf>=3.19.4",/' setup.py
grep -rl "^[[:space:]]*import mock" tests | \
    xargs sed -i -E 's/^([[:space:]]*)import mock/\1from unittest import mock/'
%generate_buildrequires
%pyproject_buildrequires


%build
%pyproject_wheel


%install
%pyproject_install
%pyproject_save_files google


%check
%if %{with tests}
mv google{,_}
%pytest tests/unit \
    -k "not test_wrap_unary_errors \
        and not test_wrap_stream_errors_invocation \
        and not test_wrap_stream_errors_iterator_initialization \
        and not test_wrap_stream_errors_during_iteration"
mv google{_,}
%endif


%files -n python3-%{srcname} -f %{pyproject_files}
%doc README.rst CHANGELOG.md SECURITY.md
%{python3_sitelib}/google_api_core-%{version}-py%{python3_version}-nspkg.pth


%changelog
* Tue Sep 26 2023 jackeyji <jackeyji@tencent.com> - 2.12.0-1
- upgrade to 2.12.0

* Tue Sep 19 2023 Miaojun Dong <zoedong@tencent.com> - 2.10.2-7
- Rebuild for protobuf-24.2

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.2-6
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Sep 07 2023 cunshunxia@tencent.com - 2.10.2-4
- Rebuilt for protobuf 3.21.12

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.10.2-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Jan 12 2023 Miaojun Dong <zoedong@tencent.com> - 2.10.2-1
- initial build
